Exiv2::XmpValue Class Referenceabstract

Base class for all Exiv2 values used to store XMP property values. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::XmpValue:
[legend]

## Public Types

enum | XmpArrayType { xaNone , xaAlt , xaBag , xaSeq }
| XMP array types.
enum | XmpStruct { xsNone , xsStruct }
| XMP structure indicator.
typedef std::auto_ptr< XmpValue > | AutoPtr
| Shortcut for a XmpValue auto pointer.
Public Types inherited from Exiv2::Value
typedef std::auto_ptr< Value > | AutoPtr
| Shortcut for a Value auto pointer.

## Public Member Functions

Creators
| XmpValue (TypeId typeId)
Accessors
XmpArrayType | xmpArrayType () const
| Return XMP array type, indicates if an XMP value is an array.
XmpStruct | xmpStruct () const
| Return XMP struct, indicates if an XMP value is a structure.
virtual long | size () const
| Return the size of the value in bytes.
virtual long | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const
| Write value to a character data buffer. More...
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()
| Virtual destructor.
virtual int | setDataArea (const byte *buf, long len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf. More...
TypeId | typeId () const
| Return the type identifier (Exif data format type).
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
virtual long | count () const =0
| Return the number of components of the value.
virtual std::ostream & | write (std::ostream &os) const =0
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual std::string | toString (long n) const
| Return the n-th component of the value as a string. The default implementation returns toString(). The behaviour of this method may be undefined if there is no n-th component.
virtual long | toLong (long n=0) const =0
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component. More...
virtual float | toFloat (long n=0) const =0
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component. More...
virtual Rational | toRational (long n=0) const =0
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component. More...
virtual long | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted. More...
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Manipulators

void | setXmpArrayType (XmpArrayType xmpArrayType)
| Set the XMP array type to indicate that an XMP value is an array.
void | setXmpStruct (XmpStruct xmpStruct=xsStruct)
| Set the XMP struct type to indicate that an XMP value is a structure.
virtual int | read (const byte *buf, long len, ByteOrder byteOrder=invalidByteOrder)
| Read the value from a character buffer. More...
virtual int | read (const std::string &buf)=0
| Set the value from a string buffer. The format of the string corresponds to that of the write() method, i.e., a string obtained through the write() method can be read by this function. More...
static XmpArrayType | xmpArrayType (TypeId typeId)
| Return XMP array type for an array Value TypeId, xaNone if typeId is not an XMP array value type.
XmpValue & | operator= (const XmpValue &rhs)
| Assignment operator. Protected so that it can only be used by subclasses but not directly.

## Additional Inherited Members

Static Public Member Functions inherited from Exiv2::Value
static AutoPtr | create (TypeId typeId)
| A (simple) factory to create a Value type. More...
Protected Member Functions inherited from Exiv2::Value
Value & | operator= (const Value &rhs)
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
Protected Attributes inherited from Exiv2::Value
bool | ok_
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Base class for all Exiv2 values used to store XMP property values.

## Member Function Documentation

## copy()

long Exiv2::XmpValue::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  | const

virtual

Write value to a character data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Note
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters

  buf | Data buffer to write to.
  byteOrder | Byte order. Not used.

Returns
  Number of characters written.

Implements Exiv2::Value.

References Exiv2::Value::write().

## read() [1/2]

int Exiv2::XmpValue::read | ( | const byte * | buf,
|  | long | len,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  |

virtual

Read the value from a character buffer.

Uses read(const std::string& buf)

Note
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters

  buf | Pointer to the data buffer to read from
  len | Number of bytes in the data buffer
  byteOrder | Byte order. Not needed.

Returns
  0 if successful.

Implements Exiv2::Value.

## read() [2/2]

virtual int Exiv2::XmpValue::read | ( | const std::string & | buf | ) |

pure virtual

Set the value from a string buffer. The format of the string corresponds to that of the write() method, i.e., a string obtained through the write() method can be read by this function.

Parameters

  buf | The string to read from.

Returns
  0 if successful.

Implements Exiv2::Value.

Implemented in Exiv2::LangAltValue, Exiv2::XmpArrayValue, and Exiv2::XmpTextValue.

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp